<?php
/*
* 2007-2012 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2012 PrestaShop SA
*  @version  Release: $Revision: 6844 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

if (!defined('_CAN_LOAD_FILES_'))
	exit;
	
class blocksocial_prest extends Module
{
	public function __construct()
	{
		$this->name = 'blocksocial_prest';
		$this->tab = 'front_office_features';
		$this->version = '1.0';

		parent::__construct();

		$this->displayName = $this->l('Block social_prest');
		$this->description = $this->l('Allows you to add extra information about social networks');
	}
	
	public function install()
	{
		return (parent::install() AND Configuration::updateValue('blocksocial_prest_facebook', '') && Configuration::updateValue('blocksocial_prest_twitter', '') && Configuration::updateValue('blocksocial_prest_gplus', '') && Configuration::updateValue('blocksocial_prest_skype', '') && $this->registerHook('displayHeader') && $this->registerHook('displayFooter'));
	}
	
	public function uninstall()
	{
		//Delete configuration			
		return (Configuration::deleteByName('blocksocial_prest_facebook') AND Configuration::deleteByName('blocksocial_prest_twitter') AND Configuration::deleteByName('blocksocial_prest_gplus') AND Configuration::deleteByName('blocksocial_prest_skype') AND parent::uninstall());
	}
	
	public function getContent()
	{
		// If we try to update the settings
		$output = '';
		if (isset($_POST['submitModule']))
		{	
			Configuration::updateValue('blocksocial_prest_facebook', (($_POST['facebook_url_prest'] != '') ? $_POST['facebook_url_prest']: ''));
			Configuration::updateValue('blocksocial_prest_twitter', (($_POST['twitter_url_prest'] != '') ? $_POST['twitter_url_prest']: ''));	
			Configuration::updateValue('blocksocial_prest_gplus', (($_POST['gplus_url_prest'] != '') ? $_POST['gplus_url_prest']: ''));		
			Configuration::updateValue('blocksocial_prest_skype', (($_POST['skype_url_prest'] != '') ? $_POST['skype_url_prest']: ''));				
			$output = '<div class="conf confirm">'.$this->l('Configuration updated').'</div>';
		}
		
		return '
		<h2>'.$this->displayName.'</h2>
		'.$output.'
		<form action="'.Tools::htmlentitiesutf8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset class="width2">				
				<label for="facebook_url_prest">'.$this->l('Facebook URL: ').'</label>
				<input type="text" id="facebook_url_prest" name="facebook_url_prest" value="'.((Configuration::get('blocksocial_prest_facebook') != "") ? Configuration::get('blocksocial_prest_facebook') : "").'" />
				<div class="clear">&nbsp;</div>		
				<label for="twitter_url_prest">'.$this->l('Twitter URL: ').'</label>
				<input type="text" id="twitter_url_prest" name="twitter_url_prest" value="'.((Configuration::get('blocksocial_prest_twitter') != "") ? Configuration::get('blocksocial_prest_twitter') : "").'" />
				<div class="clear">&nbsp;</div>	
				<label for="gplus_url_prest">'.$this->l('G+ URL: ').'</label>
				<input type="text" id="gplus_url_prest" name="gplus_url_prest" value="'.((Configuration::get('blocksocial_prest_gplus') != "") ? Configuration::get('blocksocial_prest_gplus') : "").'" />
				<div class="clear">&nbsp;</div>					
				<label for="skype_url_prest">'.$this->l('Skype: ').'</label>
				<input type="text" id="skype_url_prest" name="skype_url_prest" value="'.((Configuration::get('blocksocial_prest_skype') != "") ? Configuration::get('blocksocial_prest_skype') : "").'" />
				<div class="clear">&nbsp;</div>	
							
				<br /><center><input type="submit" name="submitModule" value="'.$this->l('Update settings').'" class="button" /></center>
			</fieldset>
		</form>';
	}
	
	public function hookDisplayHeader()
	{
		$this->context->controller->addCSS(($this->_path).'blocksocial_prest.css', 'all');
	}
		
	public function hookDisplayFooter()
	{
		global $smarty;

		$smarty->assign(array(
			'facebook_url_prest' => Configuration::get('blocksocial_prest_facebook'),
			'twitter_url_prest' => Configuration::get('blocksocial_prest_twitter'),
			'skype_url_prest' => Configuration::get('blocksocial_prest_skype'), 
			'gplus_url_prest' => Configuration::get('blocksocial_prest_gplus')
		));
		return $this->display(__FILE__, 'blocksocial_prest.tpl');
	}
}
?>
