<?php
class itemslider extends Module
{
	private $_html = '';
	private $_postErrors = array();

	function __construct()
	{
		$this->name = 'itemslider';
		$this->tab = 'others';
		$this->version = '1.0';
		$this->author = '';
		$this->need_instance = 0;

		parent::__construct();

		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('ItemSlider');
		$this->description = $this->l('Displays Products On Homepage In Carousel');
	}

	function install()
	{
		if (!Configuration::updateValue('CAROUSEL_PRODUCTS_NUMBER', 8) OR 
			!Configuration::updateValue('PRODUCTS_TYPE', 1) OR 
			!Configuration::updateValue('PRODUCTS_VISIBLE', 5) OR 
			!Configuration::updateValue('PRODUCTS_TO_SCROLL', 1) OR 
			!Configuration::updateValue('CELL_WIDTH', 196) OR 
			!parent::install() OR 
			!$this->registerHook('header') OR
			!$this->registerHook('displayHome')
			) return false;
		return true;
	}


	public function uninstall()
	{
		return (parent::uninstall());
	}

	public function getContent()
	{
		$output = '<div style="width:800px; margin:0 auto"><h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitHomeFeatured'))
		{
			Configuration::updateValue('PRODUCTS_TYPE', intval(Tools::getValue('products_type')));
			$nbr = intval(Tools::getValue('nbr'));
			$products_visible = intval(Tools::getValue('products_visible'));
			$products_to_scroll = intval(Tools::getValue('products_to_scroll'));
			$cell_width = intval(Tools::getValue('cell_width'));
			if (!$nbr OR $nbr <= 0 OR !Validate::isInt($nbr))
				$errors[] = $this->l('Invalid number of products');
			else
				Configuration::updateValue('CAROUSEL_PRODUCTS_NUMBER', $nbr);  /*---------------------*/
			if (!$products_visible OR $products_visible <= 0 OR !Validate::isInt($products_visible))
				$errors[] = $this->l('Invalid number of visible products');
			else
				Configuration::updateValue('PRODUCTS_VISIBLE', $products_visible); /*---------------------*/
			if (!$products_to_scroll OR $products_to_scroll <= 0 OR !Validate::isInt($products_to_scroll))
				$errors[] = $this->l('Invalid number of visible products');
			else
				Configuration::updateValue('PRODUCTS_TO_SCROLL', $products_to_scroll);/*---------------------*/
			if (!$cell_width OR $cell_width <= 0 OR !Validate::isInt($cell_width))
				$errors[] = $this->l('Invalid number of visible products');
			else
				Configuration::updateValue('CELL_WIDTH', $cell_width);
			if (isset($errors) AND sizeof($errors))
				$output .= $this->displayError(implode('<br />', $errors));
			else
				$output .= $this->displayConfirmation($this->l('Settings updated'));
		}
		$output .= "</div>";
		return $output.$this->displayForm();
	}

	public function displayForm()
	{
		
		$output = '
	   	<form action="'.$_SERVER['REQUEST_URI'].'" method="post" style="width:800px; margin:0 auto">
			<fieldset><legend><img src="'.$this->_path.'logo.png" width="16" height="16" alt="" title="" />'.$this->l('Carousel settings').'</legend>
			<h4>Products type</h4>
				<div style="overflow:hidden">
				<label style="text-align:right; width:200px;">'.$this->l('Featured products').'</label><input type="radio" name="products_type" value="1" '.((Configuration::get('PRODUCTS_TYPE') == 1) ? 'checked="checked" ' : '').'/>
				</div>
				<div style="overflow:hidden">
				<label style="text-align:right; width:200px;">'.$this->l('New products').'</label>
						<input type="radio" name="products_type" value="0" '.((Configuration::get('PRODUCTS_TYPE') == 0) ? 'checked="checked" ' : '').'/>
				</div>
				<h4>Quantity Products</h4>
				<div style="overflow:hidden">
				<label style="text-align:right; width:200px;">'.$this->l('The number of all products').'</label>
					<input type="text" size="1" name="nbr" value="'.(Configuration::get('CAROUSEL_PRODUCTS_NUMBER')).'" />	
				</div>
				<br/>
				<div style="overflow:hidden">
				<label style="text-align:right; width:200px;">'.$this->l('The number of visible products').'</label>
					<input type="text" size="1" name="products_visible" value="'.(Configuration::get('PRODUCTS_VISIBLE')).'" />	
				</div>
				<br/>
				<div style="overflow:hidden">
				<label style="text-align:right; width:200px;">'.$this->l('The number of items to scroll').'</label>
					<input type="text" size="1" name="products_to_scroll" value="'.(Configuration::get('PRODUCTS_TO_SCROLL')).'" />	
				</div>	
				<br/>
				<div style="overflow:hidden">
				<label style="text-align:right; width:200px;">'.$this->l('Width of product\'s cell, px').'</label>
					<input type="text" size="1" name="cell_width" value="'.(Configuration::get('CELL_WIDTH')).'" />	
				</div>				
				<br/><br/>
				<input type="submit" name="submitHomeFeatured" value="'.$this->l('Save').'" class="button" />
			</fieldset>
      	</form>';
		return $output;
	}

	public function hookDisplayHome($params)
	{
		$newProducts = Product::getNewProducts((int)($params['cookie']->id_lang), 0, (int)(Configuration::get('CAROUSEL_PRODUCTS_NUMBER')));

		$category = new Category(Context::getContext()->shop->getCategory(), Configuration::get('PS_LANG_DEFAULT'));
		$nb = (int)(Configuration::get('CAROUSEL_PRODUCTS_NUMBER'));
		$products = $category->getProducts($params['cookie']->id_lang, 1, ($nb ? $nb : 10));
		$products_visible = (int)(Configuration::get('PRODUCTS_VISIBLE'));
		$this->smarty->assign(array(
			'pth' => $this->_path,
			'featuredProducts' => $products,
			'new_products' => $newProducts,
			'products_type' => Configuration::get('PRODUCTS_TYPE'),
			'visible_products' => Configuration::get('PRODUCTS_VISIBLE'),
			'products_to_scroll' => Configuration::get('PRODUCTS_TO_SCROLL'),
			'cell_width' => Configuration::get('CELL_WIDTH')
		));

		return $this->display(__FILE__, 'itemslider.tpl');
	}

	public function hookDisplayHeader($params)
	{
		$this->context->controller->addCSS($this->_path.'css/itemslider.css', 'all');
		$category = new Category(Context::getContext()->shop->getCategory(), Configuration::get('PS_LANG_DEFAULT'));
		$nb = (int)(Configuration::get('CAROUSEL_PRODUCTS_NUMBER'));
		$products = $category->getProducts($params['cookie']->id_lang, 1, ($nb ? $nb : 10));
		$this->smarty->assign(array(
			'featuredProducts' => $products
		));
		return $this->display(__FILE__, 'header.tpl');
	}

	public function hookTop($params)
	{
		return $this->hookDisplayHome($params);
	}

}